.build-template:
    stage: build
    script:
        - echo building...
        - echo Testing contents form $CI_JOB_NAME > build-file.txt
    artifacts:
     paths:
      - build-file.txt

.test-template:
    stage: test
    script:
        - echo Running $CI_JOB_NAME and loading contents...
        - cat build-file.txt

build1:
    extends: .build-template

build2:
    extends: .build-template

test1:
    extends: .test-template
    needs:
        - build1
    dependencies:
         - build1

test2:
    extends: .test-template
    needs:
        - build2
    dependencies:
         - build2

windows-build:
 stage: build
 script: echo building for windows...

mac-build:
 stage: build
 script: echo building for mac...

windows-test1:
 script: echo running tests...
 needs:
    - windows-build

windows-test2:
 stage: test
 script: echo running tests...
 needs:
    - windows-build

mac-test1:
 stage: test
 script: echo running tests...
 needs: [mac-build]

mac-test2:
 stage: test
 script: echo running tests...
 needs:
    - mac-build
 
win_prod_deploy:
 script: echo deploying...
 stage: deploy
 needs: [windows-test1, windows-test2]

mac_prod_deploy:
 script: echo deploying...
 stage: deploy
 needs: [mac-test1, mac-test2]

